package cbpm.rtx.client.message;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cbpm.rtx.biz.im.IMBodyRequest;
import cbpm.rtx.biz.im.IMRequest;
import cbpm.rtx.biz.im.IMServiceRequest;
import cbpm.rtx.biz.im.IMServiceResponse;
import cbpm.rtx.biz.im.vo.ImVO;
import cbpm.rtx.biz.notice.BodyRequest;
import cbpm.rtx.biz.notice.Request;
import cbpm.rtx.biz.notice.ServiceRequest;
import cbpm.rtx.biz.notice.ServiceResponse;
import cbpm.rtx.biz.notice.vo.NoticeVO;
import cbpm.rtx.client.message.IESB2RTXMessage;
import cbpm.rtx.common.GolbalVariable;
import cbpm.rtx.common.Header;
import cbpm.rtx.common.log.LogFactory;
import cbpm.rtx.common.log.LogUtil;
import cbpm.rtx.utils.ConverUtil;
import cbpm.rtx.utils.PropertiesUtil;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.rmi.RemoteException;
import javax.xml.rpc.ParameterMode;
import javax.xml.rpc.ServiceException;
import org.apache.axis.client.Call;
import org.apache.axis.client.Service;
import org.apache.axis.constants.Style;
import org.apache.axis.constants.Use;
import org.apache.axis.encoding.XMLType;
import org.apache.commons.lang.StringUtils;

public class ESB2RTXMessage implements IESB2RTXMessage {
  public static String config_file = "";
  
  public ESB2RTXMessage() {}
  
  public ESB2RTXMessage(String configFile) {
    config_file = configFile;
  }
  
  public NoticeVO sendNotify(NoticeVO vo) {
    LogUtil log = LogFactory.getLog4jUtil(getClass());
    Header headRequest = new Header();
    PropertiesUtil propUtil = null;
    if (StringUtils.isNotBlank(config_file) || StringUtils.isNotEmpty(config_file)) {
      propUtil = PropertiesUtil.getInstance(config_file);
    } else {
      propUtil = PropertiesUtil.getInstance("/esb_rtx.properties");
    } 
    if (propUtil != null) {
      headRequest.setChannelId(propUtil.getProperty(GolbalVariable.CBPM_CHANNELID));
      headRequest.setServiceCode(propUtil.getProperty(GolbalVariable.CBPM_ESB_RTX_SERVICE_CODE));
      headRequest.setExtReference(propUtil.getProperty(GolbalVariable.ESB2RTX_SEND_NOTICE));
      Request request = new Request();
      request.setViewObject(vo);
      BodyRequest body = new BodyRequest();
      body.setRequest(request);
      ServiceRequest xml = new ServiceRequest();
      xml.setBody(body);
      xml.setHeader(headRequest);
      try {
        String contentXml = ConverUtil.getObjectToXml(xml);
        log.info("请求XML：" + contentXml);
        String wsdl = propUtil.getProperty(GolbalVariable.CBPM_SERVICE_WSDL);
        String method = propUtil.getProperty(GolbalVariable.CBPM_SERVICE_METHOD);
        Object[] objects = { contentXml };
        String responseXML = invokeCustom(wsdl, method, objects);
        log.info("响应XML：" + responseXML);
        ServiceResponse serviceResponse = (ServiceResponse)ConverUtil.getXmlToObject(responseXML, ServiceResponse.class);
        NoticeVO rvo = serviceResponse.getBody().getResponse().getViewObject();
        return rvo;
      } catch (MalformedURLException e) {
        e.printStackTrace();
      } catch (RemoteException e) {
        e.printStackTrace();
      } catch (IOException e) {
        e.printStackTrace();
      } catch (ServiceException e) {
        e.printStackTrace();
      } 
    } 
    return null;
  }
  
  public ImVO sendIM(ImVO vo) {
    LogUtil log = LogFactory.getLog4jUtil(getClass());
    Header headRequest = new Header();
    PropertiesUtil propUtil = null;
    if (StringUtils.isNotBlank(config_file) || StringUtils.isNotEmpty(config_file)) {
      propUtil = PropertiesUtil.getInstance(config_file);
    } else {
      propUtil = PropertiesUtil.getInstance("/esb_rtx.properties");
    } 
    if (propUtil != null) {
      headRequest.setChannelId(propUtil.getProperty(GolbalVariable.CBPM_CHANNELID));
      headRequest.setServiceCode(propUtil.getProperty(GolbalVariable.CBPM_ESB_RTX_SERVICE_CODE));
      headRequest.setExtReference(propUtil.getProperty(GolbalVariable.ESB2RTX_SEND_IM));
      IMRequest request = new IMRequest();
      request.setViewObject(vo);
      IMBodyRequest body = new IMBodyRequest();
      body.setRequest(request);
      IMServiceRequest xml = new IMServiceRequest();
      xml.setBody(body);
      xml.setHeader(headRequest);
      try {
        String contentXml = ConverUtil.getObjectToXml(xml);
        log.info("请求XML：" + contentXml);
        String wsdl = propUtil.getProperty(GolbalVariable.CBPM_SERVICE_WSDL);
        String method = propUtil.getProperty(GolbalVariable.CBPM_SERVICE_METHOD);
        Object[] objects = { contentXml };
        String responseXML = invokeCustom(wsdl, method, objects);
        log.info("请求XML：" + contentXml);
        IMServiceResponse serviceResponse = (IMServiceResponse)ConverUtil.getXmlToObject(
            responseXML, IMServiceResponse.class);
        ImVO rvo = serviceResponse.getBody().getResponse().getViewObject();
        return rvo;
      } catch (MalformedURLException e) {
        e.printStackTrace();
      } catch (RemoteException e) {
        e.printStackTrace();
      } catch (IOException e) {
        e.printStackTrace();
      } catch (ServiceException e) {
        e.printStackTrace();
      } 
    } 
    return null;
  }
  
  private static String invokeCustom(String wsdl, String method, Object[] args) throws ServiceException, MalformedURLException, RemoteException {
    Service service = new Service();
    String ret = "";
    Call call = (Call)service.createCall();
    call.setTargetEndpointAddress(new URL(wsdl));
    call.addParameter("arg1", XMLType.XSD_STRING, ParameterMode.IN);
    call.setOperationName(method);
    call.setTimeout(Integer.valueOf(60000));
    call.setReturnType(XMLType.XSD_STRING);
    call.setUseSOAPAction(true);
    call.setOperationStyle(Style.RPC);
    call.setOperationUse(Use.LITERAL);
    ret = (String)call.invoke(args);
    return ret;
  }
}
